﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Threading;
using System.Text;
using System.Windows.Forms;
using Tao.OpenGl;

//Gl_points draws points
//Gl_lines for each two vertices draw a line
//gl_polygon draw a polygon with all vertices
//gl_triangles each 3 draw triangle
//gl_line_strip connects between first and last point
//gl_lineloop
//gl_quads any 4 points
//gl_quadstrip connects quads
//gl_triangle_strip connects triangles
//gl_triangle_fan

///
///Created by: Shady Ahmed El-Yaski
///Email: shady@elyaski.com
///

namespace MyHouse
{
    public partial class Form1 : Form
    {
        public int i = 0;
        public Form1()
        {
            this.Size = new Size(512, 256);
            InitializeComponent();
            InitializationOpenGL();
        }
        private void InitializationOpenGL()
        {
            simpleOpenGlControl1.InitializeContexts();
            Gl.glMatrixMode(Gl.GL_PROJECTION);
            Gl.glLoadIdentity();
            Glu.gluOrtho2D(-100, 100, -100, 100);
        }
       
        private void simpleOpenGlControl1_Paint(object sender, PaintEventArgs e)
        {
            if (i == 0)
            {
                Gl.glClearColor(0.5333f, 0.9764f, 0.9529f, 1);
                Gl.glClear(Gl.GL_COLOR_BUFFER_BIT);
                DrawHouse(false);
                DrawSun();
            }
            else if (i == 1)
            {
                Gl.glClearColor(0.5333f, 0.9764f, 0.9529f, 1);
                Gl.glClear(Gl.GL_COLOR_BUFFER_BIT);
                DrawHouse(false);
                DrawSun();
                DrawSmoke(40, 50);
            }
            else if (i == 2)
            {
                Gl.glClearColor(0.5333f, 0.9764f, 0.9529f, 1);
                Gl.glClear(Gl.GL_COLOR_BUFFER_BIT);
                DrawHouse(false);
                DrawSun();
                DrawSmoke(40, 50);
                DrawSmoke(55, 75);
            }
            else if (i == 3)
            {
                Gl.glClearColor(0.5333f, 0.9764f, 0.9529f, 1);
                Gl.glClear(Gl.GL_COLOR_BUFFER_BIT);
                DrawHouse(false);
                DrawSun();
                DrawSmoke(40, 50);
                DrawSmoke(55, 75);
                DrawSmoke(70, 100);
            }
            else if (i == 4)
            {
                Gl.glClearColor(0.19f, 0.24f, 0.34f, 1);
                Gl.glClear(Gl.GL_COLOR_BUFFER_BIT);
                DrawMoon();
                DrawHouse(false);
            }
            else if (i == 5)
            {
                Gl.glClearColor(0.19f, 0.24f, 0.34f, 1);
                Gl.glClear(Gl.GL_COLOR_BUFFER_BIT);
                DrawMoon();
                DrawHouse(true);
            }
            else if (i == 6)
            {
                Gl.glClearColor(0.19f, 0.24f, 0.34f, 1);
                Gl.glClear(Gl.GL_COLOR_BUFFER_BIT);
                DrawMoon();
                DrawHouse(false);
            }
            else if (i == 7)
            {
                Gl.glClearColor(0.19f, 0.24f, 0.34f, 1);
                Gl.glClear(Gl.GL_COLOR_BUFFER_BIT);
                DrawMoon();
                DrawHouse(false);
                DrawzZz(-70, 20);
                DrawzZz(-58, 20);
                DrawzZz(-46, 20);
            }
            else if (i == 8)
            {
                Gl.glClearColor(0.19f, 0.24f, 0.34f, 1);
                Gl.glClear(Gl.GL_COLOR_BUFFER_BIT);
                DrawMoon();
                DrawHouse(false);
                DrawzZz(-80, 35);
                DrawzZz(-68, 35);
            }
            else if (i == 9)
            {
                Gl.glClearColor(0.19f, 0.24f, 0.34f, 1);
                Gl.glClear(Gl.GL_COLOR_BUFFER_BIT);
                DrawMoon();
                DrawHouse(false);
                DrawzZz(-90, 50);
            }
        }
        private void DrawHouse(bool lights)
        {
            //--------------Upper Triangle-----------------
            Gl.glBegin(Gl.GL_TRIANGLES);
            Gl.glColor3f(0.392f, 0.694f, 1f);
            Gl.glVertex2f(0, 50);
            Gl.glColor3f(0.7f, 0.2f, 0.4f);
            Gl.glVertex2f(-50, 0);
            Gl.glColor3f(0.2f, 0.8f, 0.7f);
            Gl.glVertex2f(50, 0);
            Gl.glEnd();
            Gl.glFlush();
            //--------------Main Rectangle-----------------
            Gl.glColor3f(0.8431f, 0.8823f, 0.0235f);
            Gl.glRectf(-50f, 0f, 50f, -100f);
            //--------------Door-----------------
            Gl.glColor3f(0.5529f, 0.4117f, 0.3529f);
            Gl.glRectf(-20f, -100f, 20f, -60f);
            Gl.glFlush();
            //----
            Gl.glBegin(Gl.GL_LINES);
            Gl.glColor3f(0f, 0f, 0f);
            Gl.glVertex2f(0, -100);
            Gl.glVertex2f(0, -60);
            Gl.glEnd();
            Gl.glFlush();
            //----
            float delta_theta = 0.01f;
            float r = 1f;
            Gl.glBegin(Gl.GL_LINE_LOOP);

            for (float angle = 0; angle < 2 * Math.PI; angle += delta_theta)
                Gl.glVertex3d(r * Math.Cos(angle) - 4, r * Math.Sin(angle) - 80, 0);

            Gl.glEnd();
            Gl.glFlush();
            Gl.glBegin(Gl.GL_LINE_LOOP);
            for (float angle = 0; angle < 2 * Math.PI; angle += delta_theta)
                Gl.glVertex3d(r * Math.Cos(angle) + 4, r * Math.Sin(angle) - 80, 0);

            Gl.glEnd();
            //--------------Windows-----------------
            Gl.glColor3f(1f, 0.2196f, 0.1098f);
            if (lights)
            {
                Gl.glBegin(Gl.GL_QUADS);
                Gl.glVertex2f(-30, -30);
                Gl.glVertex2f(-10, -30);
                Gl.glVertex2f(-10, -10);
                Gl.glVertex2f(-30, -10);
                //-----------
                Gl.glVertex2f(30, -30);
                Gl.glVertex2f(10, -30);
                Gl.glVertex2f(10, -10);
                Gl.glVertex2f(30, -10);
            }
            else
            {
                Gl.glBegin(Gl.GL_QUADS);
                Gl.glColor3f(0.6862f, 0.7372f, 0.7333f);
                Gl.glVertex2f(-30, -30);
                Gl.glColor3f(0.6329f, 0.7450f, 0.6705f);
                Gl.glVertex2f(-10, -30);
                Gl.glColor3f(0.3568f, 0.5254f, 0.6156f);
                Gl.glVertex2f(-10, -10);
                Gl.glColor3f(0.3529f, 0.4196f, 0.4156f);
                Gl.glVertex2f(-30, -10);
                //-----------
                Gl.glColor3f(0.6862f, 0.7372f, 0.7333f);
                Gl.glVertex2f(30, -30);
                Gl.glColor3f(0.6329f, 0.7450f, 0.6705f);
                Gl.glVertex2f(10, -30);
                Gl.glColor3f(0.3568f, 0.5254f, 0.6156f);
                Gl.glVertex2f(10, -10);
                Gl.glColor3f(0.3529f, 0.4196f, 0.4156f);
                Gl.glVertex2f(30, -10);
            }
            Gl.glEnd();
            Gl.glFlush();
            //--------------Chimney-----------------
            Gl.glBegin(Gl.GL_TRIANGLES);
            Gl.glColor3f(0.5529f, 0.4117f, 0.3529f);
            Gl.glVertex2f(50, 0);
            Gl.glVertex2f(50, 20);
            Gl.glVertex2f(30, 20);
            Gl.glEnd();
            Gl.glFlush();
            //-----
            Gl.glRectf(50f, 20f, 30f, 35f);
            //---------------------------------------------
        }
        private void DrawSun()
        {
            //--------------Sun Light-----------------
            Gl.glBegin(Gl.GL_LINES);
            Gl.glColor3f(0.9960f, 0.8509f, 0.2627f);
            Gl.glVertex2f(-100, 100);
            Gl.glVertex2f(-50, 50);
            Gl.glVertex2f(-100, 100);
            Gl.glVertex2f(-70, 30);
            Gl.glVertex2f(-100, 100);
            Gl.glVertex2f(-90, 20);
            Gl.glVertex2f(-100, 100);
            Gl.glVertex2f(-30, 70);
            Gl.glVertex2f(-100, 100);
            Gl.glVertex2f(-25, 90);
            Gl.glEnd();
            Gl.glFlush();
            //--------------Main Sun-----------------
            float delta_theta = 0.01f;
            float r = 40f;
            Gl.glBegin(Gl.GL_POLYGON);
            float G = 0.9921f, B = 0.949f;
            for (float angle = 0; angle < 2 * Math.PI; angle += delta_theta)
            {
                Gl.glColor3f(1f, G, B);
                Gl.glVertex3d(r * Math.Cos(angle) - 100, r * Math.Sin(angle) + 100, 0);
                G = G - 0.1f;
                B = B - 0.1f;
            }

            Gl.glEnd();
            Gl.glFlush();
            //-----------------------------------------
        }
        private void DrawSmoke(float x1, float y1)
        {
            //--------------Smokes_Two Circles-----------------
            float delta_theta = 0.01f;
            float r = 8f;
            Gl.glBegin(Gl.GL_POLYGON);
            Gl.glColor3f(1f, 1f, 1f);
            for (float angle = 0; angle < 2 * Math.PI; angle += delta_theta)
                Gl.glVertex3d(r * Math.Cos(angle) + x1 - r + 2, r * Math.Sin(angle) + y1, 0);

            Gl.glEnd();
            Gl.glFlush();
            //----------------
            Gl.glBegin(Gl.GL_POLYGON);
            for (float angle = 0; angle < 2 * Math.PI; angle += delta_theta)
                Gl.glVertex3d(r * Math.Cos(angle) + x1 + r - 2, r * Math.Sin(angle) + y1, 0);

            Gl.glEnd();
            Gl.glFlush();
            //-----------------------------------------
        }
        private void DrawMoon()
        {
            //--------------Main Moon-----------------
            float delta_theta = 0.01f;
            float r = 20f;
            Gl.glBegin(Gl.GL_POLYGON);
            float R = 1f, G = 1f, B = 1f;
            for (float angle = 0; angle < 2 * Math.PI; angle += delta_theta)
            {
                Gl.glColor3f(R, G, B);
                Gl.glVertex3d(r * Math.Cos(angle) + 70, r * Math.Sin(angle) + 70, 0);
                R = R - 0.001f;
                G = G - 0.001f;
                B = B - 0.001f;
            }

            Gl.glEnd();
            Gl.glFlush();
            //----------------
            Gl.glColor3f(0.19f, 0.24f, 0.34f);
            Gl.glBegin(Gl.GL_POLYGON);
            for (float angle = 0; angle < 2 * Math.PI; angle += delta_theta)
                Gl.glVertex3d(r * Math.Cos(angle) + 61, r * Math.Sin(angle) + 73, 0);

            Gl.glEnd();
            Gl.glFlush();
            //-----------------------------------------
        }
        private void DrawzZz(float x1, float y1)
        {
            Gl.glColor3f(0f, 0f, 0f);
            Gl.glRectf(x1, y1, x1 + 10f, y1 + 10f);

            Gl.glBegin(Gl.GL_TRIANGLES);
            Gl.glColor3f(0.19f, 0.24f, 0.34f);
            Gl.glVertex2f(x1, y1 + 2);
            Gl.glVertex2f(x1, y1 + 8);
            Gl.glVertex2f(x1 + 9, y1 + 8);

            Gl.glVertex2f(x1 + 1, y1 + 2);
            Gl.glVertex2f(x1 + 10f, y1 + 8);
            Gl.glVertex2f(x1 + 10f, y1 + 2);

            Gl.glEnd();
            Gl.glFlush();

        }
        private void simpleOpenGlControl1_MouseClick(object sender, MouseEventArgs e)
        {
            animation.Start();
        }

        private void animation_Tick(object sender, EventArgs e)
        {
            i++;
            if (i == 10)
            {
                i = 0;
                animation.Stop();
            }
            simpleOpenGlControl1.Invalidate();
        }
    }
}
///
///Created by: Shady Ahmed El-Yaski
///Email: shady@elyaski.com
///